// Generated by CoffeeScript 1.12.7
(function() {
  var Promise, build_transport, debug, mailer, markdown, path, seem, send_mail, smtpTransport,
    hasProp = {}.hasOwnProperty;

  mailer = require('nodemailer');

  path = require('path');

  Promise = require('bluebird');

  seem = require('seem');

  smtpTransport = require('nodemailer-smtp-transport');

  markdown = require('nodemailer-markdown').markdown;

  this.name = 'foamy-organization:send-mail';

  debug = (require('tangible'))(this.name);

  build_transport = function(cfg, sender) {
    var k, options, ref, transport, transporter, v;
    options = {};
    ref = cfg.mailer.SMTP;
    for (k in ref) {
      if (!hasProp.call(ref, k)) continue;
      v = ref[k];
      if (k !== 'auths') {
        options[k] = cfg.mailer.SMTP[k];
      }
    }
    if ((sender != null) && (cfg.mailer.SMTP.auths != null) && sender in cfg.mailer.SMTP.auths) {
      options.auth = cfg.mailer.SMTP.auths[sender];
    }
    debug('transport options', options);
    transporter = smtpTransport(options);
    transport = mailer.createTransport(transporter);
    if (cfg.mailer.with_markdown) {
      transport.use('compile', markdown({
        gfm: true,
        tables: true
      }));
    }
    Promise.promisifyAll(transport);
    return transport;
  };

  send_mail = function(cfg, email_options) {
    var sender;
    sender = email_options.from;
    return build_transport(cfg, sender).sendMailAsync(email_options);
  };

  module.exports = {
    send_mail: send_mail,
    build_transport: build_transport
  };

}).call(this);
